#!/usr/bin/python

import os
import gtk


def relfile(path):
	return os.path.join(os.path.dirname(__file__), path)


class AbstractUI(object):

	def __init__(self, gtkbuilder_xml_file, window_widget_name):
		self.window_widget_name = window_widget_name
		self.builder = gtk.Builder()
		self.builder.add_from_file(relfile(gtkbuilder_xml_file))
		self.builder.connect_signals(self)

	def get_object(self, objectname):
		return self.builder.get_object(objectname)

	def get_window(self):
		return self.get_object(self.window_widget_name)

	def show(self):
		self.get_window().show()

	def destroy(self):
		self.get_window().destroy()

	def errorbox(self, primary, secondary=None):
		md = gtk.MessageDialog(self.builder.get_object(self.window_widget_name),
				gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_ERROR,
				gtk.BUTTONS_CANCEL, primary)
		if secondary:
			md.format_secondary_text(secondary)
		md.run()
		md.destroy()

